<?php
/**************************************************************************************
* SigRotator.php															 		  *
***************************************************************************************
* Signature Image Rotator															  *
* Version 1.9																		  *
* By: SoLoGHoST																		  *
* Co-Creator: Shortie																  *
* http://www.graphicsmayhem.com														  *
* Copyright 2009-10 Solomon Closson													  *
* =================================================================================== *
* License Information:																  *
*																					  *
* ABOVE INFO MUST REMAIN INTACT!!													  *
**************************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');


function SigRotatorMain()
{
	global $currentVersion;

	$currentVersion = '1.7';
	
	// Load the language files
	if (loadlanguage('SigRotator') == false)
		loadLanguage('SigRotator','english');
		
	// Load the main template file
	loadtemplate('SigRotator');

	$subActions = array(
		'main' => 'SigRotatorView',
		'upload' => 'UploadImage',
		'delete' => 'DeleteImage',
		'deleteall' => 'DeleteAllImages',
		'deleteall2' => 'DeleteAllImages2',
		'sigimages' => 'ShowImages',
	);

	if (isset($_GET['sa']))
		$sa = $_GET['sa'];
	else
		SigRotatorView();

	if (!empty($subActions[$sa]))
		$subActions[$sa]();
	else
		SigRotatorView();
}

function SigRotatorView()
{
	redirectexit();
}

function UploadImage()
{
	global $user_info, $modSettings, $context, $boarddir, $smcFunc, $scripturl, $txt, $sourcedir, $memberContext, $sigInfo;
	
	// It's a guest, so don't allow them any access
	if ($context['user']['is_guest'])
		fatal_error($txt['sig_rotator_not_loggedin'],false);

	// Extra Security measures added...		
	checkSession();
	$g_enabled = allowedTo('sigrotator_images_enabled');
	$g_addimage = allowedTo('sigrotator_images_add');
	$g_nolimit = allowedTo('sigrotator_images_nolimit');
	
	$g_err = empty($g_enabled) || empty($g_addimage) ? 1 : 0;

	if (!empty($g_err) && !$context['user']['is_admin'])
		fatal_error($txt['sig_rotator_no_access'],false);
	
	// Only allow Administrators to add images to user's signature images...
	if ($context['user']['is_admin'])
		$getUserId = isset($_REQUEST['u']) ? (int) $_REQUEST['u'] : (int) $user_info['id'];
	else
		$getUserId = (int) $user_info['id'];

	// Let's check to see if they added an upload via file input before continuing.
	if (trim($_FILES['sigImg']['name']) == '')
		fatal_error($txt['sig_rotator_no_image'], false);

	// Check if the sigs folder is writable
	if (!is_writable($boarddir . '/sigs/'))
		if ($context['user']['is_admin'])
			fatal_error($txt['sig_rotator_write_error'] . $boarddir . '/sigs/');
		else
			fatal_error($txt['sig_rotator_write_err']);

	list ($sig_limits) = explode(':', $modSettings['signature_settings']);
	$sig_limits = explode(',', $sig_limits);

	$context['rotate_signature_images_enabled'] = isset($sig_limits[8]) ? $sig_limits[8] : 0;

	if (empty($context['rotate_signature_images_enabled']))
		fatal_error($txt['sig_rotator_disabled'], false);
		
		$max_images = isset($sig_limits[9]) ? $sig_limits[9] : 0;
		$max_image_width = isset($sig_limits[10]) ? $sig_limits[10] : 0;
		$max_image_height = isset($sig_limits[11]) ? $sig_limits[11] : 0;
		$prefix = isset($sig_limits[12]) ? $sig_limits[12] : 0;

	// Let's check if the user already has a folder...
    $dbresult = $smcFunc['db_query']('', '
    SELECT
    	s.id_img, s.id_member, s.date, s.orginalfilename, 
		s.filename, mem.sig_imgs_folder AS folder_name
    FROM {db_prefix}rotator_imgs AS s
	LEFT JOIN {db_prefix}members AS mem ON (s.id_member = mem.id_member)
     WHERE s.id_member = {int:memberId}
	 ORDER BY s.date ASC', array('memberId' => $getUserId));

		$total_images = $smcFunc['db_affected_rows']();

		$row = $smcFunc['db_fetch_assoc']($dbresult);

		$context['sig_rotate_folder'] = empty($row['folder_name']) ? '' : $row['folder_name'];

		$smcFunc['db_free_result']($dbresult);

	// Let's check some things here...
	if (empty($g_nolimit))
		if (!$context['user']['is_admin'])
			if (!empty($max_images) && $total_images >= $max_images)
				fatal_error($txt['sig_rotator_max_limit'], false);	
	
	$filename = '';
	$foldername = $context['sig_rotate_folder'];
	
// BEGIN Adding of the Signature Image...
if (isset($_FILES['sigImg']['name']) && $_FILES['sigImg']['name'] != '')
{
	if (empty($prefix))
		$sigprefix = preg_replace('~[^A-Za-z0-9_]~', '', normalize($context['forum_name_html_safe']));
	elseif ($prefix == 1) {
		$da_userid = array();
		$da_userid[] = $getUserId;
		
		if (!loadMemberData($da_userid))
			fatal_error($txt['sig_rotator_username_err']);
		
		foreach ($da_userid as $member)
		{	
			if (!loadMemberContext($member))
				continue;
			
			$sigprefix = preg_replace('~[^A-Za-z0-9_]~', '', normalize($memberContext[$member]['name']));		
		}
			
	} elseif ($prefix == 2)
		$sigprefix = $getUserId;
	else
		$sigprefix = 'untitled';

	// Store the original filename
	$orginalfilename = $_FILES['sigImg']['name'];
	
	// Set the Filename for the Image...
	$sig_id = $getUserId . '_' . date('d_m_y_g_i_s');

	// Set the max width max height variables to be used in the ResizeSigImage function...
	$max_width = $max_image_width != 0 ? (int) $max_image_width : 0;
	$max_height = $max_image_height != 0 ? (int) $max_image_height : 0;

	if (!empty($context['sig_rotate_folder']))
	{
		$folderpath = $boarddir . '/sigs/' . $foldername . '/';
	}
	else 
	{
		// create new folder...
		$foldername = $sigprefix . '_' . date('d_m_y_g_i_s') . '.png';
		$folderpath = $boarddir . '/sigs/' . $foldername . '/';
		$sig = $getUserId . time();
		$name = $sigprefix;
	}

	if (!is_dir($folderpath)) {
		@mkdir($folderpath);
		@chmod($folderpath, 0755);
	}

	// Let's call the function that does it all, if return is false, there was a problem... 
	if (!ResizeSigImage($_FILES['sigImg']['tmp_name'],  $folderpath . $sig_id, $max_width, $max_height)) {
		fatal_error($txt['sig_rotator_error'],false);
	}
	
	$filename = $sig_id . '_sig.' . $sigInfo['sig_fileext'];

	if (!file_exists($folderpath . 'index.php'))
		copy($boarddir . '/sigs/index.php', $folderpath . 'index.php');

}


// Create the Database entry and update

$t = time();

$smcFunc['db_insert']('replace', 
    '{db_prefix}rotator_imgs', 
    array(
		'orginalfilename' => 'string', 'filename' => 'string', 'id_member' => 'int', 'date' => 'int', 'mime_type' => 'string-20', 'fileext' => 'string-8',
	), 
    array(
		$orginalfilename, $filename, $getUserId, $t, $sigInfo['sig_mimetype'], $sigInfo['sig_fileext'],
	), 
    array('id_img') 
); 

// Update the foldername if it is new...
	$smcFunc['db_query']('','
		UPDATE {db_prefix}members
		SET sig_imgs_folder = {string:foldername}
		WHERE id_member = {int:memberId}
		LIMIT 1',
		array('foldername' => $foldername, 'memberId' => $getUserId)
		);

// Put in the url if it is new...
if (!empty($sig) && !empty($name)) {
	$smcFunc['db_insert']('replace', 
		'{db_prefix}rotator_urls', 
		array(
			'id_member' => 'int', 'sig' => 'string', 'name' => 'string',
		), 
		array(
			$getUserId, $sig, $name,
		), 
		array('id_url') 
	);
}

redirectexit('action=profile;area=forumprofile;u=' . $getUserId);
}

function DeleteImage()
{
	global $user_info, $context, $boarddir, $smcFunc, $scripturl, $txt;

	// It's a guest, so don't allow them to do this just in case they stumble upon this by accident...
	if ($context['user']['is_guest'])
		fatal_error($txt['sig_rotator_not_loggedin'],false);

	// Extra Security measures added...
	checkSession();
	$g_enabled = allowedTo('sigrotator_images_enabled');
	$g_delimage = allowedTo('sigrotator_images_delete');
	$g_admin = allowedTo('sigrotator_images_admin');
	$g_err = empty($g_enabled) || empty($g_delimage) ? 1 : 0;

	if (!empty($g_err) && empty($g_admin))
		fatal_error($txt['sig_rotator_no_access'],false);
	
	if ($context['user']['is_admin'] || !empty($g_admin))
		$getUserId = isset($_REQUEST['u']) ? (int) $_REQUEST['u'] : $user_info['id'];
	else
		$getUserId = $user_info['id'];

	//  Gets the id of the file for deletion...
	$sigFileId = (int) $_REQUEST['sigPics'];

	// We need to get the foldername from the database, so here we go...
    $dbresult = $smcFunc['db_query']('', '
    SELECT
    	m.id_member, m.sig_imgs_folder, s.filename AS filename
    FROM {db_prefix}members As m
	INNER JOIN {db_prefix}rotator_imgs AS s ON (s.id_img = ' . $sigFileId . ')
     WHERE m.id_member = {int:memberId}', 
	 array('memberId' => $getUserId)
	 );
	$row = $smcFunc['db_fetch_assoc']($dbresult);
		
	$sigFoldername = $row['sig_imgs_folder'];
	
	$sigFilename = $row['filename'];

	$smcFunc['db_free_result']($dbresult);
	
	if (empty($sigFoldername))
		fatal_error($txt['sig_rotator_folder_error'], false);

	// Let's delete the image...
	if ($sigFilename != '')
		@unlink($boarddir . '/sigs/' . $sigFoldername . '/' . $sigFilename);
	
	
	$smcFunc['db_query']('', 'DELETE FROM {db_prefix}rotator_imgs
	WHERE id_member = {int:memberId} AND filename = {string:filename} LIMIT 1',
	array('memberId' => $getUserId, 'filename' => $sigFilename));	

	// Check to see if all images in folder are empty, if so delete the folder...
	$dbresult1 = $smcFunc['db_query']('', '
	SELECT
		id_member
	FROM {db_prefix}rotator_imgs
     WHERE id_member = {int:memberId}', 
	 array('memberId' => $getUserId)
	 );
    $found = $smcFunc['db_affected_rows']();
 	$smcFunc['db_free_result']($dbresult1);

	// No more images in folder, clean up time...
	if ($found == 0) {	
		// Remove files and directory
		unlinkRecursive($boarddir . '/sigs/' . $sigFoldername . '/', true);
		
		// Remore Dir Name from database
		$smcFunc['db_query']('', '
		UPDATE {db_prefix}members
			SET sig_imgs_folder = ""
		 WHERE id_member = {int:memberId}
		 LIMIT 1', 
		 array('memberId' => $getUserId)
		 );

		$smcFunc['db_query']('', 'DELETE FROM {db_prefix}rotator_urls
		WHERE id_member = {int:memberId} LIMIT 1',
		array('memberId' => $getUserId));
	}		
redirectexit('action=profile;area=forumprofile;u=' . $getUserId);
}

// This function just asks the user if they are sure about this...
function DeleteAllImages()
{
	global $user_info, $context, $smcFunc, $txt, $mbname;

	// It's a guest, so don't allow them to do this just in case they stumble upon this by accident...
	if ($context['user']['is_guest'])
		fatal_error($txt['sig_rotator_not_loggedin'],false);

	// Extra Security measures added...
	checkSession();
	$g_enabled = allowedTo('sigrotator_images_enabled');
	$g_delimage = allowedTo('sigrotator_images_delete');
	$g_admin = allowedTo('sigrotator_images_admin');
	$g_err = empty($g_enabled) || empty($g_delimage) ? 1 : 0;

	if (!empty($g_err) && empty($g_admin))
		fatal_error($txt['sig_rotator_no_access'],false);
	
	if ($context['user']['is_admin'] || !empty($g_admin))
		$context['get_the_id'] = isset($_REQUEST['u']) ? (int) $_REQUEST['u'] : $user_info['id'];
	else
		$context['get_the_id'] = $user_info['id'];

	$context['sub_template']  = 'deleteall';

	$context['linktree'][] = array(
		'name' => $txt['sig_rotator_page_title'] . ' &gt; ' . $txt['sig_rotator_delete_all']
	);

	$context['page_title'] = $mbname . ' - ' . $txt['sig_rotator_page_title'] . ' - ' . $txt['sig_rotator_delete_all'];
	
}

// Here goes the function that actually deletes all of the images...
function DeleteAllImages2()
{
	global $user_info, $context, $boarddir, $smcFunc, $scripturl, $txt;

	$id = (int) $_REQUEST['userid'];

	// It's a guest, so don't allow them to do this just in case they stumble upon this by accident...
	if ($context['user']['is_guest'])
		fatal_error($txt['sig_rotator_not_loggedin'],false);

	// Extra Security measures added...
	checkSession();
	$g_enabled = allowedTo('sigrotator_images_enabled');
	$g_delimage = allowedTo('sigrotator_images_delete');
	$g_admin = allowedTo('sigrotator_images_admin');
	$g_err = empty($g_enabled) || empty($g_delimage) ? 1 : 0;

	if (!empty($g_err) && empty($g_admin))
		fatal_error($txt['sig_rotator_no_access'],false);

	$access_granted = !empty($g_admin) || $context['user']['is_admin'] ? 1 : 0;

	if (empty($access_granted) && $id != $user_info['id'])
		fatal_error($txt['sig_rotator_not_allowed'], false);
		
	if (empty($id))
		fatal_error($txt['sig_rotator_no_id_err'], false);
		
	// Ok, now let's begin shall we?
    $dbresult = $smcFunc['db_query']('', '
    SELECT
    	sig_imgs_folder
    FROM {db_prefix}members
     WHERE id_member = {int:memberId} LIMIT 1', 
	 array('memberId' => $id)
	 );
		$row = $smcFunc['db_fetch_assoc']($dbresult);
		$sigFoldername = $row['sig_imgs_folder'];
		$smcFunc['db_free_result']($dbresult);

	if (empty($sigFoldername))
		fatal_error($txt['sig_rotator_folder_error'], false);

	// Delete all images from the database
	$smcFunc['db_query']('', 'DELETE FROM {db_prefix}rotator_imgs
	WHERE id_member = {int:memberId}',
	array('memberId' => $id));	

	$smcFunc['db_query']('', 'DELETE FROM {db_prefix}rotator_urls
	WHERE id_member = {int:memberId} LIMIT 1',
	array('memberId' => $id));
	
	// Delete all files and the Root Folder
	unlinkRecursive($boarddir . '/sigs/' . $sigFoldername . '/', true);
		
	// Remore Dir Name from database
	$smcFunc['db_query']('', '
	UPDATE {db_prefix}members
		SET sig_imgs_folder = ""
	 WHERE id_member = {int:memberId}
	 LIMIT 1', 
	 array('memberId' => $id));

redirectexit('action=profile;area=forumprofile;u=' . $id);
}

function setTransparent(&$src, &$dst, $trn, $single)
{
	if ($single) // single-color transparent PNG?
	{
		$rgb = imagecolorsforindex($src, $trn);
		$trn = imagecolorallocate($dst, $rgb['red'], $rgb['green'], $rgb['blue']);
		imagefill($dst, 0, 0, $trn);
		imagecolortransparent($dst, $trn);
	}
	else
	{
		imagecolortransparent($dst, imagecolorallocate($dst, 0, 0, 0));
		imagealphablending($dst, false);
		imagesavealpha($dst, true);
	}
}

function ResizeSigImage($source, $dest, $max_width, $max_height)
{
	global $sourcedir, $context, $sigInfo;
	
	// if empty exit right away...
	if (!isset($source) || $source == '')
		return false;
		
	require_once($sourcedir.'/Subs-Graphics.php');

	$default_formats = array(
		'1' => 'gif',
		'2' => 'jpeg',
		'3' => 'png',
		'6' => 'bmp',
		'15' => 'wbmp'
	);

	// Is GD installed....?
	$testGD = get_extension_funcs('gd');

	// No GD?
	if (empty($testGD))
		return false;

	// Do we have GD 2, even?
	$gd2 = in_array('imagecreatetruecolor', $testGD) && function_exists('imagecreatetruecolor');
	unset($testGD);

	// Ask for more memory: we need it for this, and it'll only happen once!
	@ini_set('memory_limit', '48M');

	$success = false;
	$animated = false;
	$sizes = @getimagesize($source);

	if (empty($sizes))
		return false;

	// If we are not in the default_formats array, return false
	if (!in_array($default_formats[$sizes[2]], $default_formats))
		return false;
				
	// Get the width and height of the image...
	$width = (int) $sizes[0];		
	$height = (int) $sizes[1];

	if (empty($max_width))
		$max_width = $width;
	if (empty($max_height))
		$max_height = $height;

	// Let's set the new width and height... returned as tn_width and tn_height
	$x_ratio = $max_width / $width;
	$y_ratio = $max_height / $height;
		
	// Resize the image keeping the same aspect ratio...			
	if( ($width <= $max_width) && ($height <= $max_height) ){
		$tn_width = $width;
		$tn_height = $height;
	}elseif (($x_ratio * $height) < $max_height){
			$tn_height = ceil($x_ratio * $height);
			$tn_width = $max_width;
	}else{
			$tn_width = ceil($y_ratio * $width);
			$tn_height = $max_height;
	}

	// Create the image or if not an image return FALSE!!!
	if (isset($default_formats[$sizes[2]]) && function_exists('imagecreatefrom' . $default_formats[$sizes[2]]))
	{
		if ($sizes[2] == 6) // There is no imagecreatefrombmp() function so we define a function of our own for BMP formats ;)
			$src_img = imagecreatefrombitmap($source);
		elseif ($sizes[2] == 1 && is_ani($source)) { 
			// Animated GIF, check width and height...
			if ($width <= $max_width && $height <= $max_height)
			{
				$animated = true;
				$success = true;
				$sigInfo['sig_fileext'] = 'gif';
				$sigInfo['sig_mimetype'] = 'image/gif';
			}
			else // too big, can't animate it... sorry!
				$src_img = imagecreatefromgif($source);
		} 
		else {
			$imagecreatefrom = 'imagecreatefrom' . $default_formats[$sizes[2]];
			$src_img = @$imagecreatefrom($source);
		}
	}
	else 
	 	return false;

	// Dealing with all non-animated GIFs
	if (!$animated)
	{	
		// Get/Set the alpha transparency for the image if GIF or PNG
		if ($sizes[2] == 3 || $sizes[2] == 1) {
			$transp = $alpha = $trn = false;
			$trn = imagecolortransparent($src_img);
			$alpha = $default_formats[$sizes[2]] == 'png' && (((ord(@file_get_contents($source, false, null, 25, 1)) & 6) & 4) == 4);
			$single = $trn >= 0 && $default_formats[$sizes[2]] != 'gif';
			$transp = $trn >= 0 || $alpha;
			
			$tmp = imagecreatetruecolor($tn_width,$tn_height);
			
			if ($transp)
			setTransparent($src_img, $tmp, $trn, $single);
	
			// if png not single resample it, else resize it
			$resizeFunc = 'imagecopy' . (empty($single) ? 'resampled' : 'resized');
			$resizeFunc($tmp,$src_img,0,0,0,0,$tn_width, $tn_height,$width,$height);
		
			if ($transp) {
				if ($alpha && $tmp == $src_img)
					imagesavealpha($tmp, true);
			}		
			imagepng($tmp, $dest);
			$sigInfo['sig_fileext'] = 'png';
			$sigInfo['sig_mimetype'] = 'image/png';	
			$success = true;
		}
		else
		{
			if ($sizes[2] == 6 || $sizes[2] == 15) // BMP or WBMP format
			{			
				$tmp = imagecreatetruecolor($tn_width, $tn_height);
				imagecopyresampled($tmp, $src_img, 0, 0, 0, 0,$tn_width, $tn_height,$width, $height);
	
				// We create a png file instead of a BMP or WBMP file.  Don't want huge files on our server do we?
				imagepng($tmp, $dest);
				$sigInfo['sig_fileext'] = 'png';
				$sigInfo['sig_mimetype'] = 'image/png';
				$success = true;			
			}
			else 
			{ 
				// All that is left is JPEG so handle it!
				$tmp = imagecreatetruecolor($tn_width,$tn_height);
				// resampled looks better than resized, so resample it
				imagecopyresampled($tmp,$src_img,0,0,0,0,$tn_width, $tn_height,imagesx($src_img), imagesy($src_img));
						
				// Write the JPG file!
				imagejpeg($tmp, $dest, 100); // 100 = Best Quality JPG			
				$sigInfo['sig_fileext'] = 'jpg';
				$sigInfo['sig_mimetype'] = 'image/jpeg';
				$success = true;			
			}
		}	
		// Free the Memory
		if(!empty($tmp))
			imagedestroy($tmp);
		if (!empty($src_img))
			imagedestroy($src_img);	
	}

	// Give it a new name...	
	$newDest = $dest . '_sig.' . $sigInfo['sig_fileext'];
	
	// Is is an animated gif within the size limitations?
	if ($animated && $success) {
		if (move_uploaded_file($source, $newDest) && @chmod($newDest, 0644))
			return true;
	}
	
	// if we have success... Check if renamed and chmodded properly, else return false!
	if ($success) {
		if (@rename($dest, $newDest) && @chmod($newDest, 0644))
			return true;
		else
			return false;
	} else
		return false;
}

function imagecreatefrombitmap($p_sFile) 
{ 
	$file = fopen($p_sFile,"rb"); 
	$read = fread($file,10); 
	while(!feof($file) && ($read <> "")) 
		$read .= fread($file,1024); 
	
	$temp = unpack("H*",$read); 
	$hex = $temp[1]; 
	$header = substr($hex,0,108); 
	
	if (substr($header,0,4) == "424d") 
	{ 
		$header_parts = str_split($header,2); 
		$width = hexdec($header_parts[19].$header_parts[18]); 
		$height = hexdec($header_parts[23].$header_parts[22]); 
		unset($header_parts); 
	} 

	$x = 0; 
	$y = 1; 
	$image = imagecreatetruecolor($width,$height); 
	$body = substr($hex,108); 
	$body_size = (strlen($body)/2); 
	$header_size = ($width*$height);  
	$usePadding = ($body_size>($header_size*3)+4); 
	for ($i=0; $i<$body_size; $i+=3) 
	{
		if ($x >= $width) 
		{
			if ($usePadding) 
				$i += $width%4; 
			$x = 0; 
			$y++; 
			if ($y > $height) 
				break; 
		} 

		$i_pos = $i*2; 
		$r = hexdec($body[$i_pos+4].$body[$i_pos+5]); 
		$g = hexdec($body[$i_pos+2].$body[$i_pos+3]); 
		$b = hexdec($body[$i_pos].$body[$i_pos+1]); 
		$color = imagecolorallocate($image, $r, $g, $b); 
		imagesetpixel($image, $x, $height-$y, $color); 
		$x++; 
	} 
	unset($body); 
	return $image; 
} 

function normalize($string) {
    $table = array(
        ''=>'S', ''=>'s', ''=>'Dj', 'd'=>'dj', 'd'=>'d', ''=>'Z', ''=>'z', 'C'=>'C', 'c'=>'c', 'C'=>'C', 'c'=>'c',
        ''=>'A', ''=>'A', ''=>'A', ''=>'A', ''=>'A', ''=>'A', ''=>'A', ''=>'C', ''=>'E', ''=>'E',
        ''=>'E', ''=>'E', ''=>'I', ''=>'I', ''=>'I', ''=>'I', ''=>'N', ''=>'O', ''=>'O', ''=>'O',
        ''=>'O', ''=>'O', ''=>'O', ''=>'U', ''=>'U', ''=>'U', ''=>'U', ''=>'Y', ''=>'B', ''=>'Ss',
        ''=>'a', ''=>'a', ''=>'a', ''=>'a', ''=>'a', ''=>'a', ''=>'a', ''=>'c', ''=>'e', ''=>'e',
        ''=>'e', ''=>'e', ''=>'i', ''=>'i', ''=>'i', ''=>'i', ''=>'o', ''=>'n', ''=>'o', ''=>'o',
        ''=>'o', ''=>'o', ''=>'o', ''=>'o', ''=>'u', ''=>'u', ''=>'u', ''=>'y', ''=>'y', ''=>'b',
        ''=>'y', 'R'=>'R', 'r'=>'r',
    );
    return strtr($string, $table);
}

function unlinkRecursive($dir, $deleteRootToo) 
{ 
    if(!$dh = @opendir($dir)) 
        return; 

    while (false !== ($obj = readdir($dh))) 
    { 
        if($obj == '.' || $obj == '..') 
            continue; 

        if (!@unlink($dir . '/' . $obj)) 
            unlinkRecursive($dir.'/'.$obj, true); 
    } 
    closedir($dh);
    if ($deleteRootToo) 
        @rmdir($dir);     

    return; 
}

function ShowImages()
{
	global $smcFunc, $context, $boarddir, $user_info;

	if ($context['user']['is_guest'])
		exit;
		
	if (isset($_REQUEST['u']))
		$id = (int) $_REQUEST['u'];
	else
		exit;
	
	if (isset($_REQUEST['img']))
		$img_id = (int) $_REQUEST['img'];
	else
		exit;

	// let's check some permissions to be sure they can view these images...
	$g_enabled = allowedTo('sigrotator_images_enabled');
	$g_admin = allowedTo('sigrotator_images_admin');

	if (empty($g_enabled) && empty($g_admin))
		exit;

	$access_granted = !empty($g_admin) || $context['user']['is_admin'] ? 1 : 0;


	if (empty($access_granted) && $user_info['id'] != $id)
		exit;
		
	if (empty($id) || empty($img_id))
		exit;


    $request = $smcFunc['db_query']('', '
    SELECT
	s.orginalfilename, s.filename, s.mime_type, s.fileext, 
	mem.sig_imgs_folder AS folder_name
    FROM {db_prefix}rotator_imgs AS s
	INNER JOIN {db_prefix}members AS mem ON (s.id_member = mem.id_member)
     WHERE s.id_member = {int:memberId}
	 AND s.id_img = {int:imageId}
	 LIMIT 1', array('memberId' => $id, 'imageId' => $img_id));

	if ($smcFunc['db_num_rows']($request) === 0)
		exit;

	list ($oFilename, $nFilename, $mime_type, $file_ext, $folder) = $smcFunc['db_fetch_row']($request);

	$smcFunc['db_free_result']($request);
	
	// Only jpg or png extensions should be present...
	$is_file = $file_ext == 'jpg' || $file_ext == 'png' || $file_ext == 'gif' ? 1 : 0;
	if (empty($is_file))
		exit;	

	$path = $boarddir . '/sigs/' . $folder . '/' . $nFilename;

	if (!file_exists($path))
	{
		header('HTTP/1.0 404 Not Found');
		header('Content-Type: text/plain; charset=' . (empty($context['character_set']) ? 'ISO-8859-1' : $context['character_set']));
		die('404 - File Not Found!');
	}
	
	if (function_exists('ob_get_level'))
		while (@ob_get_level() > 0)
			@ob_end_clean();
	else
	{
		@ob_end_clean();
		@ob_end_clean();
		@ob_end_clean();
	}

	$oFilename = urlencode($oFilename);

	header('Pragma: ');
	if (!$context['browser']['is_gecko'])
		header('Content-Transfer-Encoding: binary');
	header('Expires: ' . gmdate('D, d M Y H:i:s', time() + 525600 * 60) . ' GMT');
	header('Last-Modified: ' . gmdate('D, d M Y H:i:s', filemtime($path)) . ' GMT');
	header('Accept-Ranges: bytes');
	header('Content-Length: ' . filesize($path));
	header('Content-Encoding: none');
	header('Connection: close');
	header('Content-Type: '.$mime_type);
	header('Content-Disposition: inline; filename='. $oFilename);

	if (filesize($path) > 1572864 || @readfile($path) == null)
	{
		if ($file = fopen($path, 'rb'))
		{
			while (!feof($file))
			{
				echo @fread($file, 8192);
				flush();
			}
			@fclose($file);
		}
		else
			die('Something went wrong...');
	}
obExit(false);
}

// Is it an animated GIF??
function is_ani($filename) {
    if(!($fh = @fopen($filename, 'rb')))
        return false;
    $count = 0;
    while(!feof($fh) && $count < 2)
        $chunk = fread($fh, 1024 * 100); //read 100kb at a time
        $count += preg_match_all('#\x00\x21\xF9\x04.{4}\x00\x2C#s', $chunk, $matches);
    
    fclose($fh);
    return $count > 1;
}



?>